// ___SETA43  _____
// 16/03/2024 _____
//Mando  RF 433MHz Receptor
//Arduino 1.8.19

/*
You have to go into the .h and .cpp files and change "WProgram.h" to Arduino.h
WProgram.h: No such file or directory
No se usa la librería servo, no es compatible con VirtualWire.
Se usa la librería ServoTimer2
*/
   
#include <ServoTimer2.h> 

ServoTimer2 myservo2;
ServoTimer2 myservo3;


#include <VirtualWire.h>
const int RX_DIO_Pin = 4;
 byte RxBuffer[2];

unsigned int Data;

int codeType = -1;

char direccion;

void setup() 
{
  Serial.begin(9600);
  while (!Serial) {;  }
  pinMode(13, OUTPUT); 

  myservo2.attach(2);
  myservo3.attach(3);

  vw_set_rx_pin(RX_DIO_Pin);  /* Receive at 2000 bits per second */
  vw_setup(2000);  /* Enable the receiver */
  vw_rx_start();

  pinMode(8,INPUT);pinMode(9,INPUT); pinMode(10,INPUT);
  
  delay(500);
  Serial.println("COCHE_RF_rx");
}



void loop() 
{
  delay(10);
 
   if (vw_get_message((byte *)RxBuffer, 2)) // Non-blocking
      {
        digitalWrite(13, HIGH);
        Data = RxBuffer[1];
        Serial.print(Data); Serial.print("->");
        

        switch (Data)
        {        
          case 253:
              Madelante();
              clearLed(); digitalWrite(9, HIGH);
            break;
          case 125:
              Matras();
              clearLed(); digitalWrite(10, HIGH);
            break;
          case 159:
              Mizquierda();
              clearLed(); digitalWrite(11, HIGH);
            break;
          case 31:
              Mderecha();
              clearLed(); digitalWrite(12, HIGH);
            break;
          case 221:
              Mstop();
              clearLed();
            break;
          default:
              Serial.println("Sin orden");
            break;
        }
        
      } 

}


#define T_ADELANTE 800
#define T_ATRAS 2200
#define T_PARAR 1500


void clearLed(void)
{
  digitalWrite(9, LOW); digitalWrite(10, LOW);
  digitalWrite(11, LOW); digitalWrite(12, LOW);
}


void Mstop(void)
{
  direccion=0;
  myservo2.write(T_PARAR); 
  myservo3.write(T_PARAR);
  //myservo2.detach();
  //myservo3.detach();
  Serial.println("--STOP--");
  digitalWrite(LED_BUILTIN, LOW);
}

void Mderecha(void)
{ 
  myservo2.write(T_ADELANTE); 
  myservo3.write(T_ADELANTE);
  digitalWrite(LED_BUILTIN, HIGH);
  
  if(direccion!=1)
  {
    Serial.println("Derecha");
    delay(300);
    Mstop();
  }
  else
  {
    Serial.println("Derecha2");   
    delay(100);
    myservo2.write(T_ATRAS); 
    myservo3.write(T_ADELANTE);
  }
}

void Mizquierda(void)
{
  myservo2.write(T_ATRAS); 
  myservo3.write(T_ATRAS);
  digitalWrite(LED_BUILTIN, HIGH);
  
  if(direccion!=1)
  {
    Serial.println("izquierda");
    delay(300);
    Mstop();
  }
  else
  {
    Serial.println("izquierda2");   
    delay(100);
    myservo2.write(T_ATRAS); 
    myservo3.write(T_ADELANTE);
  }  
}

void Madelante(void)
{
  direccion=1;
  myservo2.write(T_ATRAS); 
  myservo3.write(T_ADELANTE);
  Serial.println("adelante");
  digitalWrite(LED_BUILTIN, HIGH);
}

void Matras(void)
{
  direccion=-1;
  myservo2.write(T_ADELANTE); 
  myservo3.write(T_ATRAS);
  Serial.println("atras");
  digitalWrite(LED_BUILTIN, HIGH);
}
